﻿@Imports System
@Imports System.Web.Optimization
@Code
    Dim SiteMapTable = SiteMapBLL.GetListForSiteMap("calibrevb", "en")

    
    Dim StartMenu As String
    StartMenu = LibCalibreVB.BuildStartMenu(SiteMapTable)
    
    Dim referrer As String = ""
    referrer = Request.ServerVariables("HTTP_REFERER")
End Code
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <title>@PageData("Title")</title>
    <meta name="robots" content="noindex, nofollow">
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <link href="~/favicon.ico" rel="shortcut icon" type="image/x-icon" />
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href='http://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700' rel='stylesheet' type='text/css'>
    @Styles.Render("~/Content/styles")
    <link rel="shortcut icon" href="content/ico/favicon.ico">
    <link rel="apple-touch-icon-precomposed" sizes="144x144" href="/content/ico/apple-touch-icon-144-precomposed.png">
    <link rel="apple-touch-icon-precomposed" sizes="114x114" href="/content/ico/apple-touch-icon-114-precomposed.png">
    <link rel="apple-touch-icon-precomposed" sizes="72x72" href="/content/ico/apple-touch-icon-72-precomposed.png">
    <link rel="apple-touch-icon-precomposed" href="/content/ico/apple-touch-icon-57-precomposed.png">
    @Scripts.Render("~/bundles/modernizr")
</head>
<body>
    <header id="nav-bar" class="container-fluid">
        <div class="row-fluid">
            <div class="span8">
                <div id="header-container">
                    @If referrer <> "" Then
                        @<a href="javascript:history.go(-1)" class="win-backbutton"></a>
                       
                    End If

                    <h5>Calibre Library</h5>
                    <div class="dropdown">
                        <a class="header-dropdown dropdown-toggle accent-color" data-toggle="dropdown" href="#">Start
                        <b class="caret"></b>
                        </a>
                        @Html.Raw(StartMenu)
                    </div>
                </div>
            </div>
            <div id="top-info" class="pull-right">
                <a href="#" class="pull-left">
                    <div class="top-info-block">
                        <section id="login">
                            @If WebSecurity.IsAuthenticated Then
                                @<text>
                                Hello, <a class="email" href="~/Account/Manage" title="Manage">@WebSecurity.CurrentUserName</a>!
                                <form id="logoutForm" action="~/Account/Logout" method="post">
                                    @AntiForgery.GetHtml()
                                    <a href="javascript:document.getElementById('logoutForm').submit()">Log out</a>
                                </form>
                                </text>
                            Else
                                @<div>
                                    <a href="@Href("~/Account/Register")">Register</a> - <a href="@Href("~/Account/Login")">Log in</a>
                                </div>
                            End If

                        </section>
                    </div>
                    <div class="top-info-block">
                        <b class="icon-user"></b>
                    </div>
                </a>
                <hr class="separator pull-left" />
                <a id="settings" class="pull-left" href="#">
                    <b class="icon-settings"></b>
                </a>
            </div>
        </div>
    </header>

    <div id="body">
        @RenderSection("featured", required:=False)
        <section class="content-wrapper main-content clear-fix">
            @RenderBody()
        </section>
    </div>

    <div id="charms" class="win-ui-dark">
        <div id="theme-charms-section" class="charms-section">
            <div class="charms-header">
                <a href="#" class="close-charms win-command">
                    <span class="win-commandimage win-commandring">&#xe05d;</span>
                </a>
                <h2>Settings</h2>
            </div>
            <div class="row-fluid">
                <div class="span12">

                    <div class="">
                        <label for="win-theme-select">Change theme:</label>
                        <select id="win-theme-select" class="">
                            <option value="metro-ui-semilight">Semi-Light</option>
                            <option value="metro-ui-light">Light</option>
                            <option value="metro-ui-dark">Dark</option>
                        </select>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <footer>
        <div class="content-wrapper">
            <div class="float-left">
                <p>&copy; @DateTime.Now.Year - My ASP.NET Web Page</p>
            </div>
        </div>
    </footer>
    @Scripts.Render("~/bundles/jquery", "~/bundles/jqueryui", "~/bundles/others")
    @RenderSection("Scripts", required:=False)
    <script type="text/javascript">
        $(".metro").metro();
    </script>
</body>
</html>
